        integer function convert(temp)

c       this function will return the integer value of a given of a character
c       sent to it.  make sure the type of the function is declared in the main
c       body of the program.  the function is coded in this lengthy manner to
c       allow for easy alteration of any of the character's integer values.

        character*1 temp


        if (temp.eq.'A') then
           convert = 0
        else if (temp.eq.'B') then
           convert = 2
        else if (temp.eq.'C') then
           convert = 2
        else if (temp.eq.'D') then
           convert = 2
        else if (temp.eq.'E') then
           convert = 2
        else if (temp.eq.'F') then
           convert = 2
        else if (temp.eq.'G') then
           convert = 1
        else if (temp.eq.'H') then
           convert = 2
        else if (temp.eq.'I') then
           convert = 0
        else if (temp.eq.'J') then
           convert = 2
        else if (temp.eq.'K') then
           convert = 2
        else if (temp.eq.'L') then
           convert = 2
        else if (temp.eq.'M') then
           convert = 2
        else if (temp.eq.'N') then
           convert = 0
        else if (temp.eq.'O') then
           convert = 0
        else if (temp.eq.'P') then
           convert = 2
        else if (temp.eq.'Q') then
           convert = 2
        else if (temp.eq.'R') then
           convert = 2
        else if (temp.eq.'S') then
           convert = 2
        else if (temp.eq.'T') then
           convert = 2
        else if (temp.eq.'U') then
           convert = 2
        else if (temp.eq.'V') then
           convert = 2
        else if (temp.eq.'X') then
           convert = 2
        else if (temp.eq.'Y') then
           convert = 2
        else if (temp.eq.'Z') then
           convert = 0
        else
           write(*,*)'EEEE convert error '
           stop
        end if

        return
        end


        subroutine degtouv(dir, spd, u, v)

c       this subroutine will take the input direction and speed magnitudes and
c       return back to the main program the vector components of u and v for
c       averaging the vectors after they have been summed. the averaging will
c       be performed by the additional subroutine uvtodeg. this subroutine was
c       developed by example of the subroutine TRUEWIND. credit: shawn smith


        real u, v, pi, dtor, dir, mdir, spd

        x = 0.0
        y = 0.0
        pi = acos(-1.0)
        dtor = pi/180.0
                
        mdir = 270.0 - dir
        if (mdir.le.0.0) mdir = mdir + 360.0
        if (mdir.gt.0.0) mdir = mdir - 360.0

        u = spd * cos(mdir * dtor)
        v = spd * sin(mdir * dtor)

        return
        end




        subroutine degtouv2(dir, spd, u, v)

c       this subroutine will take the input direction and speed magnitudes and
c       return back to the main program the vector components of u and v for
c       averaging the vectors after they have been summed. the averaging will
c       be performed by the additional subroutine uvtodeg. this subroutine was
c       developed by example of the subroutine TRUEWIND. credit: shawn smith


        real u, v, pi, dtor, dir, mdir, spd

        x = 0.0
        y = 0.0
        pi = acos(-1.0)
        dtor = pi/180.0
                
        mdir = 90.0 - dir
        if (mdir.le.0.0) mdir = mdir + 360.0
        if (mdir.gt.0.0) mdir = mdir - 360.0

        u = spd * cos(mdir * dtor)
        v = spd * sin(mdir * dtor)

        return
        end




        subroutine uvtodeg(u, v, adir, aspd)

c       this subroutine will take the average values of the component vectors
c       u (u bar) and v (v bar), and return the average direction (dir bar) and
c       average speed (spd bar).  this subroutine is intended to be used only
c       with the subroutine degtouv only after all the values for u and v that
c       have been returned by degtouv have been averaged. this subroutine was
c       developed by example of the subroutine TRUEWIND. credit: shawn smith

        real u, v, pi, dtor, adir, madir, aspd

        pi = acos(-1.0)
        dtor = pi/180.0

        aspd = sqrt(u * u + v * v)

        if (abs(u).gt.0.00001) then
           madir = atan2(v, u)/dtor
        else
           if (abs(v).gt.0.00001) then
              madir = 180.0 - 90.0 * (v/abs(v))
           else 
              madir = 270.0
           end if
        end if

        adir = 270.0 - madir

        if (adir.lt.0.0) adir = adir + 360.0
        if (adir.gt.360.0) adir = adir - 360.0

        return
        end


        subroutine uvtodeg2(u, v, adir, aspd)

c       this subroutine will take the average values of the component vectors
c       u (u bar) and v (v bar), and return the average direction (dir bar) and
c       average speed (spd bar).  this subroutine is intended to be used only
c       with the subroutine degtouv only after all the values for u and v that
c       have been returned by degtouv have been averaged. this subroutine was
c       developed by example of the subroutine TRUEWIND. credit: shawn smith

        real u, v, pi, dtor, adir, madir, aspd

        pi = acos(-1.0)
        dtor = pi/180.0

        aspd = sqrt(u * u + v * v)

        if (abs(u).gt.0.00001) then
           madir = atan2(v, u)/dtor
        else
           if (abs(v).gt.0.00001) then
              madir = 180.0 - 90.0 * (v/abs(v))
           else 
              madir = 90.0
           end if
        end if

        adir = 90.0 - madir

        if (adir.lt.0.0) adir = adir + 360.0
        if (adir.gt.360.0) adir = adir - 360.0

        return
        end 
