      USE Module11
      implicit none

! NOTE:  This code has been considerably alter from James Lamm's original code.
!	 All major changes are denoted by introductory and closing !!!'s.  Some
!	 other minor changes may not be marked, so this is version of the code
!	 needs to be used as it is the only one that works inline w/mkcoapsimma
!	 correctly.
!	 - Barrett Olafson

! really change the Module so I need Module 11 in this version

!The 11 version provides convers attributes.  See reads version

! Version 12 makes convert units get treated more like heights

! Version 10 is more forgiving in that it allows there to be more
! than 11 times for 50-00 (you can have that with repeated minutes).
! Now we just throw away extra times and give a warning message.  Also
! we change the output file names a bit.


! this version 9 software changes the spd measure over to
! like the over vars and not dependent on u or v although
! i still need u v for the direction

! This version 8 version uses module technology

! Now we convert long from -180 thr 180 over to 0-360


!GetsFromRead_netDoesAv.f90

! this program reads the Outputfile from Read_netcdf.f90
! and provides hourly averages that go into IMMA format

!     To run this program say 

!      ../GetsFrom7.exec  ShipFileList 
!    where ShipFileList is a file that someone like Jeremy gave me
!    of netcdf file one file name per line

      logical:: DebugOn = .false.

! turn Debug to .true. or .false. if you want a lengthy dubug output to
! standard out

      integer iji,iji2,iji3, iji4, iji5, iji6repeats

      character let
     
!      integer, parameter :: NumParams = 40
!
!     This is declared in Module7 now but leave here as comment

      real :: Heights(NumParams)
      !
!     Here we store the height of various instruments when it is available
!     or -9999.0.  This matches the read program.

      integer :: Conv(NumParams)
      !
!     this is new for version 11.  This is not included in the
!     the file read in so I better get it now for 11 version

      integer iconvi1

      integer, parameter :: MaxValuesToAve = 11
!     This could change.  When written we had 50 to 00
!     and that makes 11 values.  This could change.

!     these are values stored in version 200 netcdf files at COAPS
!     plus some calculated values


      integer, dimension(MaxValuesToAve) :: time
      character, dimension(MaxValuesToAve) :: timeflags

      real, dimension(MaxValuesToAve) :: latitude
      character, dimension(MaxValuesToAve) :: latitudeflags
    
      real, dimension(MaxValuesToAve) :: longitude
      character, dimension(MaxValuesToAve) :: longitudeflags

      real, dimension(MaxValuesToAve) :: latitude2
      character, dimension(MaxValuesToAve) :: latitude2flags
    
      real, dimension(MaxValuesToAve) :: longitude2
      character, dimension(MaxValuesToAve) :: longitude2flags
    
      real, dimension(MaxValuesToAve) :: PL_HD
      character, dimension(MaxValuesToAve) :: PL_HDflags
    
      real, dimension(MaxValuesToAve) :: PL_HD2
      character, dimension(MaxValuesToAve) :: PL_HD2flags
    
      real, dimension(MaxValuesToAve) :: PL_CRS
      character, dimension(MaxValuesToAve) :: PL_CRSflags
    
      real, dimension(MaxValuesToAve) :: PL_CRS2
      character, dimension(MaxValuesToAve) :: PL_CRS2flags
    
      real, dimension(MaxValuesToAve) :: PL_CRS3
      character, dimension(MaxValuesToAve) :: PL_CRS3flags
    
      real, dimension(MaxValuesToAve) :: PL_SPD
      character, dimension(MaxValuesToAve) :: PL_SPDflags
    
      real, dimension(MaxValuesToAve) :: PL_SPD2
      character, dimension(MaxValuesToAve) :: PL_SPD2flags
    
      real, dimension(MaxValuesToAve) :: PL_SPD3
      character, dimension(MaxValuesToAve) :: PL_SPD3flags
    
      real, dimension(MaxValuesToAve) :: PL_WDIR
      character, dimension(MaxValuesToAve) :: PL_WDIRflags
    
      real, dimension(MaxValuesToAve) :: PL_WSPD
      character, dimension(MaxValuesToAve) :: PL_WSPDflags
    
      real, dimension(MaxValuesToAve) :: PL_WDIR2
      character, dimension(MaxValuesToAve) :: PL_WDIR2flags
    
      real, dimension(MaxValuesToAve) :: PL_WSPD2
      character, dimension(MaxValuesToAve) :: PL_WSPD2flags
    
      real, dimension(MaxValuesToAve) :: PL_WDIR3
      character, dimension(MaxValuesToAve) :: PL_WDIR3flags
    
      real, dimension(MaxValuesToAve) :: PL_WSPD3
      character, dimension(MaxValuesToAve) :: PL_WSPD3flags
    
      real, dimension(MaxValuesToAve) :: DIR
      character, dimension(MaxValuesToAve) :: DIRflags
    
      real, dimension(MaxValuesToAve) :: SPD
      character, dimension(MaxValuesToAve) :: SPDflags
    
      real, dimension(MaxValuesToAve) :: DIR2
      character, dimension(MaxValuesToAve) :: DIR2flags
    
      real, dimension(MaxValuesToAve) :: SPD2
      character, dimension(MaxValuesToAve) :: SPD2flags
    
      real, dimension(MaxValuesToAve) :: DIR3
      character, dimension(MaxValuesToAve) :: DIR3flags
    
      real, dimension(MaxValuesToAve) :: SPD3
      character, dimension(MaxValuesToAve) :: SPD3flags
    
      real, dimension(MaxValuesToAve) :: P
      character, dimension(MaxValuesToAve) :: Pflags
    
      real, dimension(MaxValuesToAve) :: temperature
      character, dimension(MaxValuesToAve) :: temperatureflags
    
      real, dimension(MaxValuesToAve) :: temperature2
      character, dimension(MaxValuesToAve) :: temperature2flags
    
      real, dimension(MaxValuesToAve) :: temperature3
      character, dimension(MaxValuesToAve) :: temperature3flags
    
      real, dimension(MaxValuesToAve) :: T
      character, dimension(MaxValuesToAve) :: Tflags
    
      real, dimension(MaxValuesToAve) :: T2
      character, dimension(MaxValuesToAve) :: T2flags
    
      real, dimension(MaxValuesToAve) :: TW
      character, dimension(MaxValuesToAve) :: TWflags
    
      real, dimension(MaxValuesToAve) :: TW2
      character, dimension(MaxValuesToAve) :: TW2flags
    
      real, dimension(MaxValuesToAve) :: TD
      character, dimension(MaxValuesToAve) :: TDflags
    
      real, dimension(MaxValuesToAve) :: TD2
      character, dimension(MaxValuesToAve) :: TD2flags
    
      real, dimension(MaxValuesToAve) :: RH
      character, dimension(MaxValuesToAve) :: RHflags
    
      real, dimension(MaxValuesToAve) :: RH2
      character, dimension(MaxValuesToAve) :: RH2flags
    
      real, dimension(MaxValuesToAve) :: PRECIP
      character, dimension(MaxValuesToAve) :: PRECIPflags
    
      real, dimension(MaxValuesToAve) :: RAD
      character, dimension(MaxValuesToAve) :: RADflags
    
      real, dimension(MaxValuesToAve) :: RAD2
      character, dimension(MaxValuesToAve) :: RAD2flags
    
      real, dimension(MaxValuesToAve) :: RAD3
      character, dimension(MaxValuesToAve) :: RAD3flags
    
      real, dimension(MaxValuesToAve) :: Q
      character, dimension(MaxValuesToAve) :: Qflags
    
      real, dimension(MaxValuesToAve) :: Q2
      character, dimension(MaxValuesToAve) :: Q2flags
    
      real, dimension(MaxValuesToAve) :: RRATE
      character, dimension(MaxValuesToAve) :: RRATEflags
    
      real, dimension(MaxValuesToAve) :: NONE
      character, dimension(MaxValuesToAve) :: NONEflags


      real, dimension(MaxValuesToAve) :: AllOne
      character, dimension(MaxValuesToAve) :: AllOneflags
!     !
!     I just set these to ones and Zs.  In some calculations
!     I just want to assume 1s and Zs for the flags


      real :: rr1, rr2, rr3, rr4

      integer :: PreviousTime

      integer :: yr, mo, dy, hr, min, zerotime, iipi,iipi2,iipi3,iipi4

!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!
	integer :: high360_1, low360_1, high360_2, low360_2
	integer :: high180_1, low180_1, high180_2, low180_2
	integer, parameter :: err_file = 69
	integer :: err_flag, err_exists
	character (len=200) :: command
!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!

!*********************************************************
!

!     100 sort of picked out of the air, -- way way bigger than needed right now.


      real, dimension(100) :: latitudeAvs 
    
      real, dimension(100) :: longitudeAvs

      real, dimension(100) :: latitude2Avs 
    
      real, dimension(100) :: longitude2Avs
    
      real, dimension(100) :: PL_HDAvs
    
      real, dimension(100) :: PL_HD2Avs
    
      real, dimension(100) :: PL_CRSAvs
    
      real, dimension(100) :: PL_CRS2Avs
    
      real, dimension(100) :: PL_CRS3Avs
    
      real, dimension(100) :: PL_SPDAvs
    
      real, dimension(100) :: PL_SPD2Avs
    
      real, dimension(100) :: PL_SPD3Avs
    
      real, dimension(100) :: PL_WDIRAvs
    
      real, dimension(100) :: PL_WSPDAvs
    
      real, dimension(100) :: PL_WDIR2Avs
    
      real, dimension(100) :: PL_WSPD2Avs
    
      real, dimension(100) :: PL_WDIR3Avs
    
      real, dimension(100) :: PL_WSPD3Avs
    
      real, dimension(100) :: DIRAvs
    
      real, dimension(100) :: SPDAvs
    
      real, dimension(100) :: DIR2Avs
    
      real, dimension(100) :: SPD2Avs
    
      real, dimension(100) :: DIR3Avs
    
      real, dimension(100) :: SPD3Avs
    
      real, dimension(100) :: PAvs
    
      real, dimension(100) :: temperatureAvs
    
      real, dimension(100) :: temperature2Avs
    
      real, dimension(100) :: temperature3Avs
    
      real, dimension(100) :: TAvs
    
      real, dimension(100) :: T2Avs
    
      real, dimension(100) :: TWAvs
    
      real, dimension(100) :: TW2Avs
    
      real, dimension(100) :: TDAvs
    
      real, dimension(100) :: TD2Avs
    
      real, dimension(100) :: RHAvs
    
      real, dimension(100) :: RH2Avs
    
      real, dimension(100) :: PRECIPAvs
    
      real, dimension(100) :: RADAvs
    
      real, dimension(100) :: RAD2Avs
    
      real, dimension(100) :: RAD3Avs
    
      real, dimension(100) :: QAvs
    
      real, dimension(100) :: Q2Avs
    
      real, dimension(100) :: RRATEAvs
    
      real, dimension(100) :: NONEAvs 

      real, dimension(100) :: temp1Avs

      real, dimension(100) :: temp2Avs


      logical VeryStart

      integer, parameter :: NameLength = 300

      character (Len=NameLength) :: FileName
      !
!     Filname stores the name of the file of netcdf values from
!     a cruise.  Only MaxValuesToAve have been stored for each hour.

      character (Len=NameLength) :: TempFileName
      character (Len=NameLength) :: ErrFileName
      character (Len=NameLength) :: ErrTempName

      integer,parameter ::  MainInputFile=22
      integer,parameter ::  HeightInputFile=20
      !
!     Main input file is the 11 values, flags, etc.  The Height
!     is a much later development and is just one value per variable
!     per cruise.
 
      integer,parameter :: ConvInputFile=21
      !
!     New for V. 12.

      integer, parameter :: Outputfile = 24

      integer :: count, i, j, kk,k, L, m, m, kkl, PerviousTime,iii

      integer :: convert
!     this is an external function we call from Barrett

      integer :: PlAverage, PlNumGoodP, PlNumGFlag, PlStdDev, PlHeight, PlConvU

      character*20 ShipName

      PlAverage  = 1
      PlNumGoodP = 2
      PlNumGFlag = 3
      PlStdDev   = 4
      PlHeight   = 5

      PlConvU = 6
      !
!     New for V. 12.


      iji6repeats = 0

      do iii = 1, MaxValuesToAve 
       AllOne(iii) = 1
       AllOneflags(iii) = 'Z'
      enddo 

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
	write(*,*) 'starting step 2 of 3...'

	err_flag = 0
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!

      VeryStart = .true.

      call getarg(1, FileName)

      TempFileName=FileName

      TempFileName(LEN_TRIM(TempFileName)-3:LEN_TRIM(TempFileName)+4)='IMMA.int'


!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
	ErrFileName = FileName
	ErrFileName(LEN_TRIM(ErrFileName)-3:LEN_TRIM(ErrFileName)+4)='IMMA.err'

	ErrTempName = FileName
	ErrTempName(LEN_TRIM(ErrTempName)-3:LEN_TRIM(ErrTempName)+4)='IMMA.temp'

	write(command,*)'wc -c ', TRIM(ErrFileName),' > ', TRIM(ErrTempName)
!	write(*,*) TRIM(command)
	call system(command)

	open(70, file=TRIM(ErrTempName))
	read(70,*) err_exists
	close(70)
!	write(*,*) err_exists
	if (err_exists.gt.0) then
	   err_exists = 1
	else
	   err_exists = 0
	end if
	
	write(command,*)'rm ', TRIM(ErrTempName)
!	write(*,*) TRIM(command)
	write(*,*)
	call system(command)

	open(err_file, file=TRIM(ErrFileName), status='unknown')
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!

      if (DebugOn) write(*,*) ' about to open read output files for ',FileName

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!!
      if (DebugOn) then
	 write(*,*) ' main input file is ',TRIM(FileName)//'.DataFor.int'
      end if

      open(MainInputFile,file=TRIM(FileName)//'.DataFor.int')

      if (DebugOn) write(*,*) ' about to open height input file',&
                              TRIM(FileName)//'.HeightsFor.int'

      open(HeightInputFile, file=TRIM(FileName)//'.HeightsFor.int')
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!!

      open(Outputfile,file=TRIM(TempFileName),action='write')

      read(HeightInputFile,*)Heights
      close(HeightInputFile)

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!!
      open(ConvInputFile, file=TRIM(FileName)//'.ConvUsFor.int')
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!!
      read(ConvInputFile,*)Conv 
      close(ConvInputFile)     ! New for V. 12

!     main loop of program where we go through all the readings
!     in MainInputFile and make the averages

      if (DebugOn) write(*,*) ' boing into BigLoop '

      PreviousTime= -1

      count = 0
      iji5 = 0
       !
!     iji5 is a temp variable that holds hour count for status/debug type statements

      read(MainInputFile,*) ShipName
      write(Outputfile,*)"'",TRIM(ShipName),"'"

      BigLoop: do 
        
           count = count + 1 
           read(MainInputFile,*)zerotime, yr,mo,dy,hr 

           if (zerotime .ne. previoustime) then
             iji5 = iji5 + 1

!!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!
           if (mod(iji5, 10) .eq. 0) then
	      write(*,*)' New Hour ',zerotime
	   end if

           if (VeryStart) then
             write(OutputFile,'(i4i2i2i2)')  yr, mo, dy, hr
           endif

	      high360_1 = 0
	      high360_2 = 0
	      high180_1 = 0
	      high180_2 = 0
	      low360_1 = 0
	      low360_2 = 0
	      low180_1 = 0
	      low180_2 = 0

           VerySt: if (.not. VeryStart) then

!!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!

            call MakesSimpleAvgs(latitude, latitudeflags, latitudeAvs, i-1,         'latitude    ')
            latitudeAvs(PlConvU)  =  Conv(clatitude)
            latitudeAvs(PlNumGFlag) = -8888
            !
!  MakeSimpleAvgs sets latitudeAvs(PlNumGFlag) to nG, we set it to -8888 since 
!  it really does not apply to this variable
            !
!  NOTE, this code does not get executed the very first time.  If it did i-1 would be undefined
!  but i gets a value before VeryStart is turned to false.  See code below.

            latitudeAvs(PlHeight) = -8888


            call MakesSimpleAvgs(longitude, longitudeflags, longitudeAvs,  i-1,     'longitude   ')
            longitudeAvs(PlConvU) =   Conv(clongitude)
            longitudeAvs(PlNumGFlag) = -8888
            longitudeAvs(PlHeight)   = -8888


            call MakesSimpleAvgs(latitude2, latitude2flags, latitude2Avs,  i-1,     'latitude2   ')
            latitude2Avs(PlConvU) =   Conv(clatitude2)
            latitude2Avs(PlNumGFlag) = -8888
            latitude2Avs(PlHeight) = -8888

            call MakesSimpleAvgs(longitude2,longitude2flags,longitude2Avs, i-1,     'longitude2  ')
            longitude2Avs(PlConvU) =  Conv(clongitude2)
            longitude2Avs(PlNumGFlag) = -8888
            longitude2Avs(PlHeight)   = -8888


            call MakesComplAvgs(1,    AllOne, AllOneflags, PL_HD, PL_HDflags, &
                 i-1, 'PL_HDALLONE ', Temp1Avs,            PL_HDAvs)
                 !
!  The Temp1 goes in for spd data that does not 
!  apply here so just give temp storage


            PL_HDAvs(PlNumGFlag) = -8888
            PL_HDAvs(PlHeight)   = -8888
            PL_HDAvs(PlConvU)    =    &
      Conv(cPL_HD)

            if (DebugOn) write(*,*)' endtrace--past End of MakesComplAvgs for AllOnePL_HD'


            call MakesComplAvgs(1,AllOne, AllOneflags,   PL_HD2,     PL_HD2flags, i-1,'PL_HDALLONE2', &
                                  Temp1Avs,              PL_HD2Avs)


            PL_HD2Avs(PlNumGFlag) = -8888
            PL_HD2Avs(PlHeight)   = -8888
            PL_HD2Avs(PlConvU)    =             &
      Conv(cPL_HD2)

            call MakesComplAvgs(1,PL_SPD, PL_SPDflags,   PL_CRS,     PL_CRSflags, i-1,'CRS_SPD     ', &
                                  PL_SPDAvs,             PL_CRSAvs)

            call MakesSimpleAvgs(PL_SPD, PL_SPDflags, PL_SPDAvs, i-1,                    'PL_SPD      ') 


            PL_SPDAvs(PlNumGFlag) = -8888
            PL_SPDAvs(PlHeight)   = -8888
            PL_SPDAvs(PlConvU)    =       &
      Conv(cPL_SPD)

            PL_CRSAvs(3) = -8888
            PL_CRSAvs(5) = -8888
            PL_CRSAvs(6) = &
      Conv(cPl_CRS)

            call MakesComplAvgs(1,PL_SPD2, PL_SPD2flags, PL_CRS2,   PL_CRS2flags, i-1,'CRS_SPD2    ',&
                                  PL_SPD2Avs,            PL_CRS2Avs)

            call MakesSimpleAvgs(PL_SPD2, PL_SPD2flags, PL_SPD2Avs, i-1,                 'PL_SPD2     ')

            PL_SPD2Avs(3) = -8888
            PL_SPD2Avs(5) = -8888
            PL_SPD2Avs(6) = &
      Conv(cPL_SPD2)


            PL_CRS2Avs(3) = -8888
            PL_CRS2Avs(5) = -8888
            PL_CRS2Avs(6) = &
      Conv(cPL_CRS2)

            call MakesComplAvgs(1,PL_SPD3, PL_SPD3flags, PL_CRS3,   PL_CRS3flags, i-1,'CRS_SPD3    ',&
                                  PL_SPD3Avs,            PL_CRS3Avs)

            call MakesSimpleAvgs(PL_SPD3, PL_SPD3flags, PL_SPD3Avs, i-1,                  'PL_SPD3     ')

            PL_SPD3Avs(3) = -8888
            PL_SPD3Avs(5) = -8888
            PL_SPD3Avs(6) = &
      Conv(cPL_SPD3)

            PL_CRS3Avs(3) = -8888
            PL_CRS3Avs(5) = -8888
            PL_CRS3Avs(6) = &
      Conv(cPL_CRS3)      


            call MakesComplAvgs(2,PL_WSPD, PL_WSPDflags, PL_WDIR,   PL_WDIRflags, i-1,'WSPD_WDIR   ',&
                                  PL_WSPDAvs,            PL_WDIRAvs)

            call MakesSimpleAvgs(PL_WSPD, PL_WSPDflags, PL_WSPDAvs, i-1,                 'PL_WSPD      ')

            PL_WSPDAvs(3) = -8888
            PL_WSPDAvs(5) = Heights(cPL_WSPD)
            PL_WSPDAvs(6) =    Conv(cPL_WSPD)  

            PL_WDIRAvs(3) = -8888
            PL_WDIRAvs(5) = Heights(cPL_WDIR)
            PL_WDIRAvs(6) =    Conv(cPL_WDIR)

            call MakesComplAvgs(2,PL_WSPD2,PL_WSPD2flags,PL_WDIR2,  PL_WDIR2flags,i-1,'WSPD_WDIR2  ',&
                                  PL_WSPD2Avs,           PL_WDIR2Avs)

            call MakesSimpleAvgs(PL_WSPD2, PL_WSPD2flags, PL_WSPD2Avs, i-1,                  'PL_WSPD2    ')

            PL_WSPD2Avs(3) = -8888
            PL_WSPD2Avs(5) = Heights(cPL_WSPD2)
            PL_WSPD2Avs(6) =    Conv(cPL_WSPD2)               

            PL_WDIR2Avs(3) = -8888
            PL_WDIR2Avs(5) = Heights(cPL_WDIR2) 
            PL_WDIR2Avs(6) =    Conv(cPL_WDIR2)

            call MakesComplAvgs(2,PL_WSPD3,PL_WSPD3flags,PL_WDIR3,  PL_WDIR3flags,i-1,'WSPD_WDIR2  ',&
                                  PL_WSPD3Avs,           PL_WDIR3Avs)

            call MakesSimpleAvgs(PL_WSPD3, PL_WSPD3flags, PL_WSPD3Avs, i-1,                  'PL_WSPD3    ')

            PL_WSPD3Avs(3) = -8888
            PL_WSPD3Avs(5) = Heights(cPL_WSPD3)
            PL_WSPD3Avs(6) =    Conv(cPL_WSPD3)           


            PL_WDIR3Avs(3) = -8888
            PL_WDIR3Avs(5) = Heights(cPL_WDIR3)  
            PL_WDIR3Avs(6) =    Conv(cPL_WDIR3)

            call MakesComplAvgs(2,SPD,     SPDflags,     DIR,       DIRflags,     i-1,'SPD_DIR     ',&
                                  SPDAvs,                DirAvs)

            DIRAvs(3) = -8888
            DIRAvs(5) = Heights(cDIR)
            DIRAvs(6) =    Conv(cDIR)

            call MakesSimpleAvgs(SPD, SPDflags, SPDAvs, i-1,                     'SPD         ')

            SPDAvs(5) = Heights(cSPD)
            SPDAvs(6) =    Conv(cSPD)

            call MakesComplAvgs(2,SPD2,    SPD2flags,    DIR2,      DIR2flags,    i-1,'SPD_DIR2    ',&
                                  SPD2Avs,               DIR2Avs)

            DIR2Avs(3) = -8888
            DIR2Avs(5) = Heights(cDIR2)
            DIR2Avs(6) =    Conv(cDIR2)

            call MakesSimpleAvgs(SPD2, SPD2flags, SPD2Avs, i-1,                  'SPD2        ') 
            SPD2Avs(5) = Heights(cSPD2)
            SPD2Avs(6) =    Conv(cSPD2)


            call MakesComplAvgs(2,SPD3,    SPD3flags,    DIR3,      DIR3flags,    i-1,'SPD_DIR3    ',&
                                  SPD3Avs,               DIR3Avs)

            DIR3Avs(3) = -8888
            DIR3Avs(5) = Heights(cDIR3)
            DIR3Avs(6) =    Conv(cDIR3)

            call MakesSimpleAvgs(SPD3, SPD3flags, SPD3Avs, i-1,                  'SPD3        ')

            SPD3Avs(5) = Heights(cSPD3)
            SPD3Avs(6) =    Conv(cSPD3)

            call MakesSimpleAvgs(P, Pflags, PAvs, i-1,                  'P           ')

            PAvs(5) = Heights(cP)
            PAvs(6) =    Conv(cP)

            call MakesSimpleAvgs(temperature, temperatureflags, temperatureAvs, i-1,    'temperature ')

            temperatureAvs(5) = Heights(ctemperature)
            temperatureAvs(6) =    Conv(ctemperature)

            call MakesSimpleAvgs(temperature2, temperature2flags, temperature2Avs, i-1, 'temperature2')
             
            temperature2Avs(5) = Heights(ctemperature2)
            temperature2Avs(6) =    Conv(ctemperature2)

            call MakesSimpleAvgs(temperature3, temperature3flags, temperature3Avs, i-1, 'temperature3')
           
            temperature3Avs(5) = Heights(ctemperature3)
            temperature3Avs(6) =    Conv(ctemperature3)


            call MakesSimpleAvgs(T, Tflags, TAvs, i-1,                'T           ')

            TAvs(5) = Heights(cT)
            TAvs(6) =    Conv(cT)

            call MakesSimpleAvgs(T2, T2flags, T2Avs, i-1,             'T2          ')
 
            T2Avs(5) = Heights(cT2)
            T2Avs(6) =    Conv(cT2)

            call MakesSimpleAvgs(TW, TWflags, TWAvs, i-1,             'TW          ')
          
            TWAvs(3) = -8888
            TWAvs(5) = Heights(cTW)
            TWAvs(6) =    Conv(cTW)

            call MakesSimpleAvgs(TW2, TW2flags, TW2Avs, i-1,          'TW2         ')

            TW2Avs(3) = -8888
            TW2Avs(5) = Heights(cTW2)
            TW2Avs(6) =    Conv(cTW2) 

            call MakesSimpleAvgs(TD, TDflags, TDAvs, i-1,             'TD          ')

            TDAvs(3) = -8888
            TDAvs(5) = Heights(cTD)
            TDAvs(6) =    Conv(cTD)

            call MakesSimpleAvgs(TD2, TD2flags, TD2Avs, i-1,          'TD2         ')

            TD2Avs(3) = -8888
            TD2Avs(5) = Heights(cTD2)
            TD2Avs(6) =    Conv(cTD2)


            call MakesSimpleAvgs(RH, RHflags, RHAvs, i-1,             'RH          ')

            RHAvs(5) = Heights(cRH)
            RHAvs(6) =    Conv(cRH)

            call MakesSimpleAvgs(RH2, RH2flags, RH2Avs, i-1,          'RH2         ')

            RH2Avs(5) = Heights(cRH2)
            RH2Avs(6) =    Conv(cRH2)

            call MakesSimpleAvgs(PRECIP, PRECIPflags, PRECIPAvs, i-1, 'PRECIP      ')

            PRECIPAvs(3) = -8888
            PRECIPAvs(5) = Heights(cPRECIP)
            PRECIPAvs(6) =    Conv(cPRECIP)

            call MakesSimpleAvgs(RAD, RADflags, RADAvs, i-1,          'RAD         ')

            RADAvs(3) = -8888
            RADAvs(5) = Heights(cRAD)
            RADAvs(6) =    Conv(cRAD)

            call MakesSimpleAvgs(RAD2, RAD2flags, RAD2Avs, i-1,       'RAD2        ')

            RAD2Avs(3) = -8888
            RAD2Avs(5) = Heights(cRAD2)
            RAD2Avs(6) =    Conv(cRAD2)

            call MakesSimpleAvgs(RAD3, RAD3flags, RAD3Avs, i-1,       'RAD3        ')

            RAD3Avs(3) = -8888
            RAD3Avs(5) = Heights(cRAD3)
            RAD3Avs(6) =    Conv(cRAD3)

            call MakesSimpleAvgs(Q, Qflags, QAvs, i-1,                'Q           ')

            QAvs(3) = -8888
            QAvs(5) = Heights(cQ)
            QAvs(6) =    Conv(cQ)

            call MakesSimpleAvgs(Q2, Q2flags, Q2Avs, i-1,             'Q2          ')

            Q2Avs(3) = -8888
            Q2Avs(5) = Heights(cQ2)
            Q2Avs(6) =    Conv(cQ2)

            call MakesSimpleAvgs(RRATE, RRATEflags, RRATEAvs, i-1,    'RRATE       ')

            RRATEAvs(3) = -8888
            RRATEAvs(5) = Heights(cRRATE)
            RRATEAvs(6) =    Conv(cRRATE)

            call MakesSimpleAvgs(NONE, NONEflags, NONEAvs, i-1,       'NONE        ')

            NONEAvs(3) = -8888
            NONEAvs(5) = Heights(cNONE)
            NONEAvs(6) =    Conv(cNONE)

            call MakeOuts(2,latitudeAvs,       latitude2Avs,    Temp1Avs,       'LA')
            call MakeOuts(2,longitudeAvs,      longitude2Avs,   Temp1Avs,       'LO')
            call MakeOuts(2,PL_HDAvs,          PL_HD2Avs,       Temp2Avs,       'HD')
            call MakeOuts(3,PL_CRSAvs,         PL_CRS2Avs,      PL_CRS3Avs,     'CR')
            call MakeOuts(3,PL_SPDAvs,         PL_SPD2Avs,      PL_SPD3Avs,     'SS' )
            call MakeOuts(3,PL_WSPDAvs,        PL_WSPD2Avs,     PL_WSPD3Avs,    'RS' )
            call MakeOuts(3,PL_WDIRAvs,        PL_WDIR2Avs,     PL_WDIR3Avs,    'RD' )
            call MakeOuts(3,DIRAvs,            DIR2Avs,         DIR3Avs,        'WD' )
            call MakeOuts(3,SPDAvs,            SPD2Avs,         SPD3Avs,        'WS' )
            call MakeOuts(1,PAvs,              Temp1Avs,        Temp2Avs,       'PA' )
            call MakeOuts(3,temperatureAvs,    temperature2Avs, temperature3Avs,'TS' )
            call MakeOuts(2,TAvs,              T2Avs,           Temp1Avs,       'TA' )
            call MakeOuts(2,TWAvs,             TW2Avs,          Temp1Avs,       'TW' )
            call MakeOuts(2,TDAvs,             TD2Avs,          Temp1Avs,       'TD' )
            call MakeOuts(2,RHAvs,             RH2Avs,          Temp1Avs,       'RH' )

            if (zerotime .ge. 0) then 
              write(OutputFile,*) -9898
              write(OutputFile,'(i4i2i2i2)')  yr, mo, dy, hr
            else
              write(OutputFile,*) -9777
            endif
           endif VerySt
           i=1
           previoustime = zerotime
         endif

!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!
	if (i .eq. (MaxValuesToAve+1) ) then
	   err_flag = 1
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
           write(*,*)'WARNING: REPEATED COAPS TIME IN HOUR ', zerotime
	   write(*,*)'         REPEATED JULIAN TIME IN HOUR', yr, mo, dy, hr
           write(err_file,*)'WARNING: REPEATED COAPS TIME IN HOUR ', zerotime
	   write(err_file,*)'         REPEATED JULIAN TIME IN HOUR ', yr, mo, dy, hr
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!


          iji6repeats = iji6repeats + 1
          i = i - 1
!         we still need to read this in to get over it so we will and read over our old 11th 
!         value
         endif

!        write(*,*)' zzzzzz time is  ',zerotime
         if (zerotime .lt. -11000) then
           if (DebugOn) write(*,*) ' exiting loop'
           exit BigLoop
         endif

         if (DebugOn) write(*,*)'Debug: about to read ',i,' from ',count, previoustime

         read(MainInputFile, '(1a)' ) timeflags(i)

         if (DebugOn)  write(*,*)' time flags(i) i',timeflags(i),i

        read(MainInputFile,'(1a)') let   ! skips over parameter name
        read(MainInputFile,*) latitude(i)
        read(MainInputFile,'(1a)') latitudeflags(i)

!       if (DebugOn) write(*,*) 'read in latitude ', latitude(i), latitudeflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) longitude(i)
        read(MainInputFile,'(1a)') longitudeflags(i)

!       if (DebugOn) write(*,*) 'read in longitude ', longitude(i), longitudeflags(i)


!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!
	if ( longitude(i) .gt. -8000 ) then
           if (longitude(i) .lt. -181.0 ) then
	      err_flag = 1
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!' 
              write(*,*)'ERROR: INVALID LONGITUDE VALUE ',longitude(i)
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	      write(*,*)
	      write(err_file,*)'ERROR: INVALID LONGITUDE VALUE ',longitude(i)
	      stop
           endif
           if (longitude(i) .gt. 361.0 ) then
	      err_flag = 1
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!' 
              write(*,*)'ERROR: INVALID LONGITUDE VALUE ',longitude(i)
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	      write(*,*)
	      write(err_file,*)'ERROR: INVALID LONGITUDE VALUE ',longitude(i)
	      stop
            endif
        endif
   
	if (longitude(i).gt.165.0.and.longitude(i).le.180.0) then
	   high180_1 = 1
	end if
	if (longitude(i).gt.345.0.and.longitude(i).le.360.0) then
	   high360_1 = 1
	end if
	if (longitude(i).lt.-165.0.and.longitude(i).ge.-180.0) then
	   low180_1 = 1
	end if
	if (longitude(i).ge.0.0.and.longitude(i).lt.15.0) then
	   low360_1 = 1
	end if

!	print*, yr, mo, dy, hr
!	print*, 'low 180_1 val: ', low180_1
!	print*, 'high 180_1 val: ', high180_1
!	print*, i

	if (high180_1.eq.1.and.low180_1.eq.1) then
	   if (longitude(i).gt.165.0) then
	      longitude(i) = longitude(i) - 360.0
	      high180_1 = 0
	   else if (longitude(i).lt.-165.0) then
	      longitude(i) = longitude(i) + 360.0
	      low180_1 = 0
	   end if
	end if

	if (high360_1.eq.1.and.low360_1.eq.1) then
	   if (longitude(i).gt.345.0) then
	      longitude(i) = longitude(i) - 360.0
	      high360_1 = 0
	   else if (longitude(i).lt.15.0) then
	      longitude(i) = longitude(i) + 360.0
	      low360_1 = 0
	   end if
	end if

!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!

        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_HD(i)
        read(MainInputFile,'(1a)') PL_HDflags(i)

        if (DebugOn) write(*,*) 'read in PL_HD ', PL_HD(i), PL_HDflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_HD2(i)
        read(MainInputFile,'(1a)') PL_HD2flags(i)

!       if (DebugOn) write(*,*) 'read in PL_HD2 ', PL_HD2(i), PL_HD2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_CRS(i)
        read(MainInputFile,'(1a)') PL_CRSflags(i)

!       if (DebugOn) write(*,*) 'read in PL_CRS ', PL_CRS(i), PL_CRSflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_CRS2(i)
        read(MainInputFile,'(1a)') PL_CRS2flags(i)

!       if (DebugOn) write(*,*) 'read in PL_CRS2 ', PL_CRS2(i), PL_CRS2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_CRS3(i)
        read(MainInputFile,'(1a)') PL_CRS3flags(i)

        if (DebugOn) write(*,*) 'read in PL_CRS3 ', PL_CRS3(i), PL_CRS3flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_SPD(i)
        read(MainInputFile,'(1a)') PL_SPDflags(i)

        if (DebugOn) write(*,*) 'read in PL_SPD ', PL_SPD(i), PL_SPDflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_SPD2(i)
        read(MainInputFile,'(1a)') PL_SPD2flags(i)

!       if (DebugOn) write(*,*) 'read in PL_SPD2 ', PL_SPD2(i), PL_SPD2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_SPD3(i)
        read(MainInputFile,'(1a)') PL_SPD3flags(i)

!       if (DebugOn) write(*,*) 'read in PL_SPD3 ', PL_SPD3(i), PL_SPD3flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_WDIR(i)
        read(MainInputFile,'(1a)') PL_WDIRflags(i)

!       if (DebugOn) write(*,*) 'read in PL_WDIR ', PL_WDIR(i), PL_WDIRflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_WSPD(i)
        read(MainInputFile,'(1a)') PL_WSPDflags(i)

        if (DebugOn) write(*,*) 'read in PL_WSPD ', PL_WSPD(i), PL_WSPDflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_WDIR2(i)
        read(MainInputFile,'(1a)') PL_WDIR2flags(i)

!       if (DebugOn) write(*,*) 'read in PL_WDIR2 ', PL_WDIR2(i), PL_WDIR2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_WSPD2(i)
        read(MainInputFile,'(1a)') PL_WSPD2flags(i)

!       if (DebugOn) write(*,*) 'read in PL_WSPD2 ', PL_WSPD2(i), PL_WSPD2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_WDIR3(i)
        read(MainInputFile,'(1a)') PL_WDIR3flags(i)

!       if (DebugOn) write(*,*) 'read in PL_WDIR3 i', PL_WDIR3(i), PL_WDIR3flags(i), i
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PL_WSPD3(i)
        read(MainInputFile,'(1a)') PL_WSPD3flags(i)

!       if (DebugOn) write(*,*) 'read in PL_WSPD3 ', PL_WSPD3(i), PL_WSPD3flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) DIR(i)
        read(MainInputFile,'(1a)') DIRflags(i)

!       if (DebugOn) write(*,*) 'read in DIR ', DIR(i), DIRflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) SPD(i)
        read(MainInputFile,'(1a)') SPDflags(i)

!       if (DebugOn) write(*,*) 'read in SPD ', SPD(i), SPDflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) DIR2(i)
        read(MainInputFile,'(1a)') DIR2flags(i)

!       if (DebugOn) write(*,*) 'read in DIR2 ', DIR2(i), DIR2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) SPD2(i)
        read(MainInputFile,'(1a)') SPD2flags(i)

!       if (DebugOn) write(*,*) 'read in SPD2 ', SPD2(i), SPD2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) DIR3(i)
        read(MainInputFile,'(1a)') DIR3flags(i)

        if (DebugOn) write(*,*) 'read in DIR3 ', DIR3(i), DIR3flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) SPD3(i)
        read(MainInputFile,'(1a)') SPD3flags(i)

!       if (DebugOn) write(*,*) 'read in SPD3 ', SPD3(i), SPD3flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) P(i)
        read(MainInputFile,'(1a)') Pflags(i)

!       if (DebugOn) write(*,*) 'read in P ', P(i), Pflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) temperature(i)
        read(MainInputFile,'(1a)') temperatureflags(i)

        if (DebugOn) write(*,*) 'read in temperature ', temperature(i), temperatureflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) temperature2(i)
        read(MainInputFile,'(1a)') temperature2flags(i)

!       if (DebugOn) write(*,*) 'read in temperature2 ', temperature2(i), temperature2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) temperature3(i)
        read(MainInputFile,'(1a)') temperature3flags(i)

!       if (DebugOn) write(*,*) 'read in temperature3 ', temperature3(i), temperature3flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) T(i)
        read(MainInputFile,'(1a)') Tflags(i)

!       if (DebugOn) write(*,*) 'read in T i', T(i), Tflags(i),i
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) T2(i)
        read(MainInputFile,'(1a)') T2flags(i)

!       if (DebugOn) write(*,*) 'read in T2 ', T2(i), T2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) TW(i)
        read(MainInputFile,'(1a)') TWflags(i)

!       if (DebugOn) write(*,*) 'read in TW ', TW(i), TWflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) TW2(i)
        read(MainInputFile,'(1a)') TW2flags(i)

        if (DebugOn) write(*,*) 'read in TW2 ', TW2(i), TW2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) TD(i)
        read(MainInputFile,'(1a)') TDflags(i)

!       if (DebugOn) write(*,*) 'read in TD ', TD(i), TDflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) TD2(i)
        read(MainInputFile,'(1a)') TD2flags(i)

!       if (DebugOn) write(*,*) 'read in TD2 ', TD2(i), TD2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) RH(i)
        read(MainInputFile,'(1a)') RHflags(i)

        if (DebugOn) write(*,*) 'read in RH ', RH(i), RHflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) RH2(i)
        read(MainInputFile,'(1a)') RH2flags(i)

!       if (DebugOn) write(*,*) 'read in RH2 ', RH2(i), RH2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) PRECIP(i)
        read(MainInputFile,'(1a)') PRECIPflags(i)

        if (DebugOn) write(*,*) 'read in PRECIP ', PRECIP(i), PRECIPflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) RAD(i)
        read(MainInputFile,'(1a)') RADflags(i)

        if (DebugOn) write(*,*) 'read in RAD ', RAD(i), RADflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) RAD2(i)
        read(MainInputFile,'(1a)') RAD2flags(i)

!       if (DebugOn) write(*,*) 'read in RAD2 ', RAD2(i), RAD2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) RAD3(i)
        read(MainInputFile,'(1a)') RAD3flags(i)

!       if (DebugOn) write(*,*) 'read in RAD3 i', RAD3(i), RAD3flags(i),i
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) Q(i)
        read(MainInputFile,'(1a)') Qflags(i)

        if (DebugOn) write(*,*) 'read in Q ', Q(i), Qflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) Q2(i)
        read(MainInputFile,'(1a)') Q2flags(i)

!       if (DebugOn) write(*,*) 'read in Q2 ', Q2(i), Q2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) RRATE(i)
        read(MainInputFile,'(1a)') RRATEflags(i)

        if (DebugOn) write(*,*) 'read in RRATE ', RRATE(i), RRATEflags(i)

        read(MainInputFile,'(1a)') let   ! skips over parameter name
        read(MainInputFile,*) latitude2(i)
        read(MainInputFile,'(1a)') latitude2flags(i)

!       if (DebugOn) write(*,*) 'read in latitude ', latitude(i), latitudeflags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) longitude2(i)

!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!
	if ( longitude2(i) .gt. -8000 ) then
           if (longitude2(i) .lt. -181.0 ) then
	      err_flag = 1
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!' 
              write(*,*)'ERROR: INVALID LONGITUDE VALUE ',longitude2(i)
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	      write(*,*)
	      write(err_file,*)'ERROR: INVALID LONGITUDE VALUE ',longitude2(i)
	      stop
           endif
           if (longitude2(i) .gt. 361.0 ) then
	      err_flag = 1
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!' 
              write(*,*)'ERROR: INVALID LONGITUDE VALUE ',longitude2(i)
	      write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	      write(*,*)
	      write(err_file,*)'ERROR: INVALID LONGITUDE VALUE ',longitude2(i)
	      stop
            endif
        endif   

	if (longitude2(i).gt.165.0.and.longitude2(i).le.180.0) then
	   high180_2 = 1
	end if
	if (longitude2(i).gt.345.0.and.longitude2(i).le.360.0) then
	   high360_2 = 1
	end if
	if (longitude2(i).lt.-165.0.and.longitude2(i).ge.-180.0) then
	   low180_2 = 1
	end if
	if (longitude2(i).ge.0.0.and.longitude2(i).lt.15.0) then
	   low360_2 = 1
	end if

	if (high180_2.eq.1.and.low180_2.eq.1) then
	   if (longitude2(i).gt.165.0) then
	      longitude2(i) = longitude2(i) - 360.0
	      high180_2 = 0
	   else if (longitude2(i).lt.-165.0) then
	      longitude2(i) = longitude2(i) + 360.0
	      low180_2 = 0
	   end if
	end if

	if (high360_2.eq.1.and.low360_2.eq.1) then
	   if (longitude2(i).gt.345.0) then
	      longitude2(i) = longitude2(i) - 360.0
	      high360_2 = 0
	   else if (longitude2(i).lt.15.0) then
	      longitude2(i) = longitude2(i) + 360.0
	      low360_2 = 0
	   end if
	end if

!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!

        read(MainInputFile,'(1a)') longitude2flags(i)
  
        read(MainInputFile,'(1a)') let 
        read(MainInputFile,*) NONE(i)
        read(MainInputFile,'(1a)') NONEflags(i)

!       if (DebugOn) write(*,*) 'read in NONE ', NONE(i), NONEflags(i)

         i = i + 1       
         VeryStart = .false.
       enddo BigLoop

!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!!
	if (iji6repeats .gt. 0) then
	   err_flag = 1
	   write(*,*)
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)'WARNING: THERE WERE ',iji6repeats,' REPEATED TIMES'
	   write(err_file,*)
	   write(err_file,*)'WARNING: THERE WERE ',iji6repeats,' REPEATED TIMES'
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	endif

	close(err_file)

	if (err_flag.eq.0.and.err_exists.eq.0) then
	   write(*,*)
	   write(*,*)'No errors in step 2'
	   write(command,*) 'rm ', TRIM(ErrFileName)
	   write(*,*) TRIM(command)
	   call system(command)
	else
	   write(*,*)
	   write(*,*) 'ERROR FILE: ', TRIM(ErrFileName)
	end if

	write(*,*) 'step 2 of 3 complete.'
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!

       stop

       contains


       subroutine MakesSimpleAvgs(Vals, Valsflags, ValsAve, numreadings,Name)

       character (Len=*) :: Name

       integer :: numreadings, NumGood,i, iji1, iji2

       integer :: MinGood 
       integer :: NumGFlag 

       real, dimension(MaxValuesToAve) :: Vals
       character, dimension(MaxValuesToAve) :: Valsflags

       real, dimension(100) :: ValsAve

       real :: rval1

       MinGood = 1

       if (DebugOn) write(*,*)' in MksSimAvgs ',Name

       do iji1 = 1, 100
        ValsAve(iji1) =  0.0
       enddo


       if (numreadings .lt. 1) then

        do iji1 = 1, 100
         ValsAve(iji1) =  -20000.0
        enddo
        return
       endif

       NumGood = 0

       GoThrIF: do i = 1, numreadings
       if ((.not. ( (convert(timeflags(i)) .gt. 1).or.      &
                    (convert(latitudeflags(i)) .gt. 1).or.  &
                    (convert(longitudeflags(i)) .gt. 1).or. &
                    (convert(Valsflags(i)) .gt. 1)        &
                  )   &
            )&
           .and. (Vals(i) .gt. -8000) &
           ) then
            NumGood = NumGood + 1
            ValsAve(1) = ValsAve(1) + Vals(i)
        endif
       enddo GoThrIF

       iji1 = 0
       GoThrIF2: do i = 1, numreadings
        if ((.not. ( (convert(timeflags(i)) .ne. 0).or.      &
                     (convert(latitudeflags(i)) .ne. 0).or.  &
                     (convert(longitudeflags(i)) .ne. 0).or. &
                     (convert(Valsflags(i)) .ne. 0)       &
                   )   &
             )&
           .and. (Vals(i) .gt. -8000) &
           ) then
            iji1 = iji1 + 1
        endif
       enddo GoThrIF2

       NumGFlag = NumGood - iji1

!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!!
	if (NumGFlag .lt. 0) then
	   err_flag = 1
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)'ERROR: SERIOUS PROGRAM FAILURE WITH NumGFlag'
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)
	   write(err_file,*)'ERROR: SERIOUS PROGRAM FAILURE WITH NumGFlag'
	   stop
	endif
!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!!!

       if (NumGood .lt. 1) then
           do iji1 = 1, 100
            ValsAve(iji1) =  -20000.0
          enddo
          return
       endif

       ValsAve(1) = ValsAve(1) / real(NumGood)
       ValsAve(2) = NumGood
       ValsAve(3) = NumGFlag

       rval1 = ValsAve(1)

       GoThrIF3: do i = 1, numreadings
       if ((.not. ( (convert(timeflags(i)) .gt. 1).or.      &
                    (convert(latitudeflags(i)) .gt. 1).or.  &
                    (convert(longitudeflags(i)) .gt. 1).or. &
                    (convert(Valsflags(i)) .gt. 1)        &
                  )   &
            )&
           .and. (Vals(i) .gt. -8000) &
           ) then
            ValsAve(4) = ValsAve(4) + ( (Vals(i) - rval1)* (Vals(i) - rval1 ) )
        endif
       enddo GoThrIF3

       if (NumGood .eq. 1) then
         ValsAve(4) = -9999
       else
         ValsAve(4) = sqrt( ValsAve(4) / (real(NumGood) - 1.0) )
       endif

       return
       end subroutine MakesSimpleAvgs




       subroutine MakesComplAvgs(ind, Spd, Spdflags, Dir, Dirflags, numreadings, Name, &
                                  ValsAve1, ValsAve2)

       character (Len=*) :: Name

       integer :: ind

       integer :: iji1

       integer :: numreadings, NumGood, i, NumGFGood

       integer :: MinGood

       real, dimension(100) :: ValsAve1, ValsAve2

       real, dimension(MaxValuesToAve) :: Spd
       character, dimension(MaxValuesToAve) :: Spdflags

       real, dimension(MaxValuesToAve) :: Dir
       character, dimension(MaxValuesToAve) :: Dirflags

       real :: u, uflag

       real :: adir, aspd

       real :: v, vflag

       real :: rtempu, rtempv

       integer :: NumValsToAve, SumAve,SqAve

       integer :: PlAverage, PlNumGoodP, PlNumGFlag, PlStdDev

       PlAverage  = 1
       PlNumGoodP = 2
       PlNumGFlag = 3
       PlStdDev   = 4


       MinGood = 1

       if (DebugOn) write(*,*)' in MksCompAvgs ',Name

       if (numreadings .lt. MinGood) then
        do iji1 = 1, 100
         ValsAve1(iji1) =  -20000.0
         ValsAve2(iji1) =  -20000.0
        enddo
        return
       endif

       NumGood = 0
       u = 0.0
       v = 0.0
       uflag = 0.0
       vflag = 0.0

!!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!
	if ((ind .ne. 1) .and. (ind .ne. 2) ) then
	   err_flag = 1
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)'ERROR: UNABLE TO CHANGE DEGREE READING TO COMPONENT FORM'
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)
	   write(err_file,*)'ERROR: UNABLE TO CHANGE DEGREE READING TO COMPONENT FORM'
	   stop
	endif
!!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!


       GoThrDF: do i = 1, numreadings
!      we GO THRough readings Discarding Flag info
         if ((.not. ( (convert(timeflags(i)) .gt. 1).or.      &
                      (convert(latitudeflags(i)) .gt. 1).or.  &
                      (convert(longitudeflags(i)) .gt. 1) .or. &
                      ( max( convert( Spdflags(i) ), convert( Dirflags(i) ) ) .gt. 1)  &
                    )   &
            )&
           .and. (Spd(i) .gt. -8000) .and. (Dir(i) .gt. -8000)&
           ) then
          NumGood = NumGood + 1
          if (ind .eq. 1) then
            call degtouv2(dir(i), spd(i), rtempu, rtempv)
          else
            call degtouv(dir(i), spd(i), rtempu, rtempv)
          endif    
          u = u + rtempu
          v = v + rtempv
         endif
       enddo GoThrDF

       if (NumGood .lt. MinGood) then
        do iji1 = 1, 100
         ValsAve1(iji1) =  -20000.0
         ValsAve2(iji1) =  -20000.0
        enddo
        return
       endif

       u =                        u / (NumGood+0.0)
       v =                        v / (NumGood+0.0)

       iji1 = 0

       GoThr2DF: do i = 1, numreadings
!      we GO THRough readings Discarding Flag info
         if ((.not. ( (convert(timeflags(i)) .ne. 0).or.      &
                      (convert(latitudeflags(i)) .ne. 0).or.  &
                      (convert(longitudeflags(i)) .ne. 0) .or. &
                      ( max( convert( Spdflags(i) ), convert( Dirflags(i) ) ) .ne. 0)  &
                    )   &
             )&
           .and. (Spd(i) .gt. -8000) .and. (Dir(i) .gt. -8000)&
           ) then
          iji1 = iji1 + 1
         endif
       enddo GoThr2DF

       NumGFGood =  NumGood - iji1

!!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!
	if (NumGFGood .lt. 0) then
	   err_flag = 1
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)'ERROR: SERIOUS PROGRAM FAILURE NumGFGood'
	   write(*,*)'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
	   write(*,*)
	   write(err_file,*)'ERROR: SERIOUS PROGRAM FAILURE NumGFGood'
	   stop
	endif
!!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!

       if (ind .eq. 1) then
            call uvtodeg2(u, v, adir, aspd)
       else
            call uvtodeg (u, v, adir, aspd)
       endif 

       ValsAve1(PlAverage) = aspd
       ValsAve2(PlAverage) = adir

       ValsAve1(PlNumGoodP) = NumGood
       ValsAve2(PlNumGoodP) = NumGood
       
       ValsAve1(PlNumGFlag) = NumGFGood
       ValsAve2(PlNumGFlag) = NumGFGood

       ValsAve1(PlStdDev) = -9999.0
       ValsAve2(PlStdDev) = -9999.0

       return
       end subroutine MakesComplAvgs




       subroutine MakeOuts(Max, One, Two, Three, Label)

       integer :: Max, iii

       character*2 Label

       integer :: PlAverage, P1NumGoodP, P1NumGFlag, P1StdDev, PlHeight, PlConv
       !
!      PlConv new to version 12 
    

       real, dimension(100) :: One, Two, Three

       integer ToUse(3), NumToDo, NumToUseSoFar

       PlAverage  = 1
       P1NumGoodP = 2
       P1NumGFlag = 3
       P1StdDev   = 4 
       PlHeight   = 5

       PlConv = 6
       !
! New for V. 12

       ToUse(1) = 0
       ToUse(2) = 0
       ToUse(3) = 0
       NumToUseSoFar = 0 


!     When called, variables are loaded from left to right but not
!     all may be full for a certain ship.  Max says the most for this
!     type of var for any ship. It will be  <= 3.  We don't want to look at vars
!     beyond what max says. 

!!!!!!!!!!CHANGES TO LAMM CODE BY OLAFSON!!!!
	if (Label.eq.'LO') then
!	   do i = 1, 100
	      if (One(PlAverage).lt.0.0) then
		 One(PlAverage) = One(PlAverage) + 360.0
	      end if
	      if (Two(PlAverage).lt.0.0) then
		 Two(PlAverage) = Two(PlAverage) + 360.0
	      end if
	      if (Three(PlAverage).lt.0.0) then
		 Three(PlAverage) = Three(PlAverage) + 360.0
	      end if
!	   end do
	end if
!!!!!!!!!!END CHANGES!!!!!!!!!!!!!!!!!!!!!!!!

       if (One(PlAverage) .gt. -12000) then
         NumToUseSoFar = NumToUseSoFar + 1 
         ToUse(NumToUseSoFar) = 1
       endif

       if ( (Max .gt. 1) .and. (Two(PlAverage) .gt. -12000) ) then 
         NumToUseSoFar = NumToUseSoFar + 1
         ToUse(NumToUseSoFar) = 2
       endif

       if ( (Max .gt. 2) .and. (Three(PlAverage) .gt. -12000) ) then 
         NumToUseSoFar = NumToUseSoFar + 1
         ToUse(NumToUseSoFar) = 3
       endif

       NumToDo = NumToUseSoFar

       if (NumToDo .gt. 0) then
        write(Outputfile,*) -1
        write(Outputfile,*) "'",Label,"'"
        write(Outputfile,*)NumToDo
        do iii = 1, NumToDo
         If (ToUse(iii) .eq. 1) then
           write(Outputfile,*) One(PlAverage)
           write(Outputfile,*) One(PlStdDev)
           write(Outputfile,*) One(PlNumGoodP)
           write(Outputfile,*) One(PlConv) 
           write(Outputfile,*) One(PlHeight)
!           write(*,*) One(PlHeight),' ',Label
           write(Outputfile,*) One(P1NumGFlag)
         endif


         If (ToUse(iii) .eq. 2) then
           write(Outputfile,*) Two(PlAverage)
           write(Outputfile,*) Two(PlStdDev)
           write(Outputfile,*) Two(PlNumGoodP)
           write(Outputfile,*) Two(PlConv) 
           write(Outputfile,*) Two(PlHeight)
!           write(*,*) Two(PlHeight),' ',Label
           write(Outputfile,*) Two(P1NumGFlag)
         endif

         If (ToUse(iii) .eq. 3) then
           write(Outputfile,*) Three(PlAverage)
           write(Outputfile,*) Three(PlStdDev)
           write(Outputfile,*) Three(PlNumGoodP)
           write(Outputfile,*) Three(PlConv) 
           write(Outputfile,*) Three(PlHeight)
!           write(*,*) Three(PlHeight),' ',Label
           write(Outputfile,*) Three(P1NumGFlag)
         endif

        enddo
       endif

       return
       end subroutine

       end
