	program mkcoapsimma

* This program is the wrapper that produces the hourly-avergaed coaps version of
* imma records given a listfile with one minute observations.  There are two
* output files; *.out and a *.sum files.  The *.out file is the coapsimma 
* record.  the *.sum file are the summary statistics compiled while using the
* wrtimma.f program given to us (and modified for coaps purposes).
* NOTE: One can keep all intermediate files created through this process by
*	entering '-l' has the fourth input to mkcoapsimma.

	character*150 rundir, infile, tempfile, command, indir, check
	integer len_rundir, len_infile, len_tempfile, len_command, len_indir, 
     +		len_check

	call getarg(1, rundir)
	len_rundir = lengthb(rundir)
	call getarg(2, indir)
	len_indir = lengthb(indir)
	call getarg(3, infile)
	len_infile = lengthb(infile)
	call getarg(4, check)
	len_check = lengthb(check)

	i = index(infile(1:len_infile), '.list')
	tempfile = (infile(1:i)//'IMMA.int')
	len_tempfile = lengthb(tempfile)
*	print*, (tempfile(1:len_tempfile))
*	print*, (infile(1:len_infile))
	
	if (infile.eq.'all') then

       	   command = ('find '//indir(1:len_indir)//'*.list > '//indir(1:len_indir)//'list.int')
	   len_command = lengthb(command)
	   print*, (command(1:len_command))
	   call system (command)

	   k = 1

	   open(10, file=indir(1:len_indir)//'list.int', status='old')
	   print*, indir(1:len_indir)//'list.int'

15	   format (150(120a))
20	   read(10, 15, end=25) infile


	      len_infile=lengthb(infile)
	      i = index(infile(1:len_infile), '.list')
	      tempfile = (infile(1:i)//'IMMA.int')
	      len_tempfile = lengthb(tempfile)
*	      print*, (tempfile(1:len_tempfile))
*	      print*, (infile(1:len_infile))


	      command = (rundir(1:len_rundir)//'Reads12.exec '//infile(1:len_infile))
	      len_command = lengthb(command)
	      print*, (command(1:len_command))
	      call system (command)
	      print*

	      command = (rundir(1:len_rundir)//'GetsFrom12.exec  '//infile(1:len_infile))
	      len_command = lengthb(command)
	      print*, (command(1:len_command))
	      call system (command)
	      print*

	      command = (rundir(1:len_rundir)//'wrtimma_v003  '//tempfile(1:len_tempfile))
	      len_command = lengthb(command)
	      print*, (command(1:len_command))
	      call system (command)
	      print*

	   go to 20

	else

	   command = (rundir(1:len_rundir)//'Reads12.exec '//indir(1:len_indir)//infile(1:len_infile))
	   len_command = lengthb(command)
	   print*, (command(1:len_command))
	   call system (command)
	   print*

	   command = (rundir(1:len_rundir)//'GetsFrom12.exec  '//indir(1:len_indir)//infile(1:len_infile))
	   len_command = lengthb(command)
	   print*, (command(1:len_command))
	   call system (command)
	   print*

	   command = (rundir(1:len_rundir)//'wrtimma_v003  '//indir(1:len_indir)//tempfile(1:len_tempfile))
	   len_command = lengthb(command)
	   print*, (command(1:len_command))
	   call system (command)
	   print*

	end if

25	if (check(1:len_check).eq.'-l') then

	   print*, ('All *.int files left non-deleted for debugging')

	else

	   command = ('rm '//indir(1:len_indir)//'*.int')
	   len_command = lengthb(command)
	   print*, (command(1:len_command))
	   call system (command)

	end if

	print*, ('mkcoapsimma complete.')

	end

!--------------------------------------------------------------------!

c 	this FUNCTION returns the length of a string terminated by
c 	a blank character. credit: shawn smith

	integer FUNCTION lengthb(achar)

	character* (*) achar
	character*1 null
	integer i

	null=char(32)
	do 10 i = len(achar),1,-1
           if (achar(i:i) .ne. null) then
              lengthb = i
              return
           endif   
10   	continue

	return
	end
